#include <stdlib.h>
#include <stdio.h>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>

int width, height;
int xmin, ymin;
float currentPosition[2];
float step = 0.9;

#define P_DECAY 0
#define P_CIRCLE 1
/* Je laisse de la place pour ajouter d'autres problemes */
#define M_EULER 10
#define M_MIDPOINT 11
#define M_TRAPEZE 12
#define M_RK4 13
#define M_EULER_IMPL 14

void (*problem)(float x[2], float r[2]);
void (*method)();


void decayForce(float x[2], float r[2])
{
  r[1] = -0.1*x[1];
  r[0] = 0.01;
}

void circularForce(float x[2], float r[2])
{
  float d;

  d = sqrt(x[0]*x[0] + x[1]*x[1]);
  r[0] = -0.1*x[1]/d;
  r[1] = 0.1*x[0]/d;
}

void eulerStep()
{
  /* Une fonction a ecrire */
}

void midpointStep()
{
  /* Une fonction a ecrire */
}

void trapezeStep()
{
  /* Une fonction a ecrire */
}

void RK4Step()
{
  /* Une fonction a ecrire */
}

void eulerImplicitStep()
{
  /* Une fonction a ecrire */
}

void idle()
{
  glLineWidth(2.0);
  glBegin(GL_LINES);
  glVertex2f(currentPosition[0], currentPosition[1]);
  (*method)();
  glVertex2f(currentPosition[0], currentPosition[1]);
  glEnd();
  glFlush();
}


void display()
{

}

void
mouse(int button, int state, int x, int y)
{
  float xp, yp;
  
  if (state == GLUT_DOWN) {
    currentPosition[0] = -1 + (2.0*(x-xmin))/(float)height;
    currentPosition[1] =  1 - (2.0*(y-ymin))/(float)height;
  } 

  glutPostRedisplay();
}


void printHelp()
{
  printf("ODE integration\n\n");
}

void parsekey(unsigned char key, int x, int y)
{
  switch (key)
    {
    case 27: exit(0);
    case ' ':
      glClearColor(0.0, 0.0, 0.1, 1.0);
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
      break;
    case 'h':
      printHelp();
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void parsekey_special(int key, int x, int y)
{
  switch (key)
    {
    case GLUT_KEY_UP: 
      step *= 2;
      printf("%f \n", step);
      break;
    case GLUT_KEY_DOWN:	
      step /= 2;
      printf("%f \n", step);
      break;
    case GLUT_KEY_RIGHT: 
      step *= 1.5;
      printf("%f \n", step);
      break;
    case GLUT_KEY_LEFT:	 
      step /= 1.5;
      printf("%f \n", step);
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void myReshape(int w, int h)
{
  xmin = 0;
  ymin = 0;
  if (w > h) {
    xmin = (w-h)/2;
    w = h;
  } else {
    ymin = (h-w)/2;
    h = w;
  }
  width = w;
  height = h;
  glViewport(xmin, ymin, w, h);
  glutPostRedisplay();
}

void myinit(void)
{
  glLoadIdentity();
  glColor3f(1.0, 0.0, 0.0);
  glClearColor(0.0, 0.0, 0.1, 1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  problem = decayForce;
  method = eulerStep;
}

void handle_main_menu(int item)
{
  switch(item) {
  case P_DECAY:
    problem = decayForce;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case P_CIRCLE:
    problem = circularForce;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case M_EULER:
    method = eulerStep;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case M_MIDPOINT:
    method = midpointStep;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case M_TRAPEZE:
    method = trapezeStep;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case M_RK4:
    method = RK4Step;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  case M_EULER_IMPL:
    method = eulerImplicitStep;
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
    glutPostRedisplay();
    break;
  }
}

int main(int argc, char *argv[]) 
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE | GLUT_MULTISAMPLE );
  glutCreateWindow("ODE integration");
  glutDisplayFunc(display);
  glutInitWindowSize(1200, 1200);
  glutInitWindowPosition(200, 0);
  glutMouseFunc(mouse);
  glutIdleFunc(idle);
  glutKeyboardFunc(parsekey);
  glutSpecialFunc(parsekey_special);
  glutReshapeFunc(myReshape);
  myinit();
  printHelp();
    
  glutCreateMenu(handle_main_menu);
  glutAddMenuEntry("Problemes", -1);
  glutAddMenuEntry("-----------------", -1);
  glutAddMenuEntry("Decroissance", P_DECAY);
  glutAddMenuEntry("Circulaire", P_CIRCLE);
  glutAddMenuEntry("-----------------", -1);
  glutAddMenuEntry("Methodes ", -1);
  glutAddMenuEntry("-----------------", -1);
  glutAddMenuEntry("Euler", M_EULER);
  glutAddMenuEntry("Midpoint", M_MIDPOINT);
  glutAddMenuEntry("Trapeze", M_TRAPEZE);
  glutAddMenuEntry("RK4", M_RK4);
  glutAddMenuEntry("Euler implicite", M_EULER_IMPL);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
  glutMainLoop();
  return 0;
}
